"use strict";
/**
 * Copyright ou © ou Copr. Ministère de l'Europe et des Affaires étrangères (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * Ce logiciel est un programme informatique servant à faciliter la création
 * d'applications Web conformément aux référentiels généraux français : RGI, RGS et RGAA
 * <p/>
 * Ce logiciel est régi par la licence CeCILL soumise au droit français et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA
 * sur le site "http://www.cecill.info".
 * <p/>
 * En contrepartie de l'accessibilité au code source et des droits de copie,
 * de modification et de redistribution accordés par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
 * seule une responsabilité restreinte pèse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concédants successifs.
 * <p/>
 * A cet égard  l'attention de l'utilisateur est attirée sur les risques
 * associés au chargement,  à l'utilisation,  à la modification et/ou au
 * développement et à la reproduction du logiciel par l'utilisateur étant
 * donné sa spécificité de logiciel libre, qui peut le rendre complexe à
 * manipuler et qui le réserve donc à des développeurs et des professionnels
 * avertis possédant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
 * logiciel à leurs besoins dans des conditions permettant d'assurer la
 * sécurité de leurs systèmes et ou de leurs données et, plus généralement,
 * à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.
 * <p/>
 * Le fait que vous puissiez accéder à cet en-tête signifie que vous avez
 * pris connaissance de la licence CeCILL, et que vous en avez accepté les
 * termes.
 * <p/>
 * <p/>
 * Copyright or © or Copr. Ministry for Europe and Foreign Affairs (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * This software is a computer program whose purpose is to facilitate creation of
 * web application in accordance with french general repositories : RGI, RGS and RGAA.
 * <p/>
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 * <p/>
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 * <p/>
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 * <p/>
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 *
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/**
 * applitutoriel-js-lite - Application tutoriel utilisant le Framework hornet
 *
 * @author MEAE - Ministère de l'Europe et des Affaires étrangères
 * @version v5.4.1
 * @link git+https://github.com/diplomatiegouvfr/applitutoriel-modules.git
 * @license CECILL-2.1
 */
var logger_1 = require("hornet-js-logger/src/logger");
var ref_ville_mod_1 = require("applitutoriel-js-lite/src/models/ref/ref-ville-mod");
var ref_pay_mod_1 = require("applitutoriel-js-lite/src/models/ref/ref-pay-mod");
var seq_sec_mod_1 = require("applitutoriel-js-lite/src/models/adm/seq-sec-mod");
var model_produit_1 = require("applitutoriel-js-lite/src/models/pro/model-produit");
var ref_civilite_mod_1 = require("applitutoriel-js-lite/src/models/ref/ref-civilite-mod");
var seq_user_mod_1 = require("applitutoriel-js-lite/src/models/seq-user-mod");
var seq_par_mod_1 = require("applitutoriel-js-lite/src/models/par/seq-par-mod");
var seq_pro_par_mod_1 = require("applitutoriel-js-lite/src/models/par/seq-pro-par-mod");
var seq_photo_model_1 = require("applitutoriel-js-lite/src/models/seq-photo-model");
var model_role_1 = require("applitutoriel-js-lite/src/models/model-role");
var model_role_utilisateur_1 = require("applitutoriel-js-lite/src/models/model-role_utilisateur");
var dec_seq_entity_1 = require("hornet-js-database/src/decorators/dec-seq-entity");
var sequelize_utils_1 = require("hornet-js-database/src/sequelize/sequelize-utils");
var injectable_1 = require("hornet-js-core/src/inject/injectable");
var inject_1 = require("hornet-js-core/src/inject/inject");
var hornet_sequelize_model_1 = require("hornet-js-database/src/sequelize/hornet-sequelize-model");
var logger = logger_1.Logger.getLogger("applitutoriel.src.dao.model-dao");
var ModelDAO = /** @class */ (function (_super) {
    tslib_1.__extends(ModelDAO, _super);
    function ModelDAO(conf) {
        var _this = _super.call(this, conf) || this;
        _this.initVilleEntity();
        _this.initUtilisateurEntity();
        _this.initRoleEntity();
        _this.initPartenaireEntity();
        _this.initProduitEntity();
        return _this;
    }
    ModelDAO_1 = ModelDAO;
    // METHODS
    ModelDAO.prototype.initVilleEntity = function () {
        sequelize_utils_1.SequelizeUtils.initRelationBelongsTo({ fromEntity: this.villeEntity,
            toEntity: this.paysEntity, alias: "lePays", foreignKey: "id_pays" });
    };
    ModelDAO.prototype.initUtilisateurEntity = function () {
        sequelize_utils_1.SequelizeUtils.initRelationBelongsToMany({ fromEntity: this.utilisateurEntity,
            toEntity: this.roleEntity, alias: "listeRole", foreignKey: "id_utilisateur", throughTable: "role_utilisateur" });
    };
    ModelDAO.prototype.initRoleEntity = function () {
        sequelize_utils_1.SequelizeUtils.initRelationBelongsToMany({ fromEntity: this.roleEntity,
            toEntity: this.utilisateurEntity, alias: "listeUser", foreignKey: "id_role", throughTable: "role_utilisateur" });
    };
    ModelDAO.prototype.initPartenaireEntity = function () {
        sequelize_utils_1.SequelizeUtils.initRelationBelongsTo({ fromEntity: this.partenaireEntity,
            toEntity: this.paysEntity, alias: "laNationalite", foreignKey: "id_pays" });
        sequelize_utils_1.SequelizeUtils.initRelationBelongsTo({ fromEntity: this.partenaireEntity,
            toEntity: this.villeEntity, alias: "laVille", foreignKey: "id_ville" });
        sequelize_utils_1.SequelizeUtils.initRelationBelongsTo({ fromEntity: this.partenaireEntity,
            toEntity: this.civiliteEntity, alias: "laCivilite", foreignKey: "id_civilite" });
        sequelize_utils_1.SequelizeUtils.initRelationBelongsToMany({ fromEntity: this.partenaireEntity,
            toEntity: this.produitEntity, alias: "listeProduit", foreignKey: "id_partenaire", throughTable: "produit_partenaire" });
        sequelize_utils_1.SequelizeUtils.initRelationBelongsTo({ fromEntity: this.partenaireEntity,
            toEntity: this.photoEntity, alias: "laPhoto", foreignKey: "id_photo" });
    };
    ModelDAO.prototype.initProduitEntity = function () {
        sequelize_utils_1.SequelizeUtils.initRelationBelongsToMany({ fromEntity: this.produitEntity,
            toEntity: this.partenaireEntity, alias: "partenaires", foreignKey: "id_produit", throughTable: "produit_partenaire" });
    };
    var ModelDAO_1;
    tslib_1.__decorate([
        dec_seq_entity_1.Entity("ville", ref_ville_mod_1.VilleModel),
        tslib_1.__metadata("design:type", Object)
    ], ModelDAO.prototype, "villeEntity", void 0);
    tslib_1.__decorate([
        dec_seq_entity_1.Entity("pays", ref_pay_mod_1.PaysModel),
        tslib_1.__metadata("design:type", Object)
    ], ModelDAO.prototype, "paysEntity", void 0);
    tslib_1.__decorate([
        dec_seq_entity_1.Entity("civilite", ref_civilite_mod_1.CiviliteModel),
        tslib_1.__metadata("design:type", Object)
    ], ModelDAO.prototype, "civiliteEntity", void 0);
    tslib_1.__decorate([
        dec_seq_entity_1.Entity("produit", model_produit_1.ProduitModel),
        tslib_1.__metadata("design:type", Object)
    ], ModelDAO.prototype, "produitEntity", void 0);
    tslib_1.__decorate([
        dec_seq_entity_1.Entity("secteur", seq_sec_mod_1.SecteurModel),
        tslib_1.__metadata("design:type", Object)
    ], ModelDAO.prototype, "secteurEntity", void 0);
    tslib_1.__decorate([
        dec_seq_entity_1.Entity("utilisateur", seq_user_mod_1.UtilisateurModel),
        tslib_1.__metadata("design:type", Object)
    ], ModelDAO.prototype, "utilisateurEntity", void 0);
    tslib_1.__decorate([
        dec_seq_entity_1.Entity("role", model_role_1.RoleModel),
        tslib_1.__metadata("design:type", Object)
    ], ModelDAO.prototype, "roleEntity", void 0);
    tslib_1.__decorate([
        dec_seq_entity_1.Entity("role_utilisateur", model_role_utilisateur_1.RoleUtilisateurModel),
        tslib_1.__metadata("design:type", Object)
    ], ModelDAO.prototype, "roleUtilisateurEntity", void 0);
    tslib_1.__decorate([
        dec_seq_entity_1.Entity("partenaire", seq_par_mod_1.PartenaireModel),
        tslib_1.__metadata("design:type", Object)
    ], ModelDAO.prototype, "partenaireEntity", void 0);
    tslib_1.__decorate([
        dec_seq_entity_1.Entity("produit_partenaire", seq_pro_par_mod_1.ProduitPartenaireModel),
        tslib_1.__metadata("design:type", Object)
    ], ModelDAO.prototype, "produitPartenaireEntity", void 0);
    tslib_1.__decorate([
        dec_seq_entity_1.Entity("photo", seq_photo_model_1.PhotoModel),
        tslib_1.__metadata("design:type", Object)
    ], ModelDAO.prototype, "photoEntity", void 0);
    ModelDAO = ModelDAO_1 = tslib_1.__decorate([
        injectable_1.injectable(ModelDAO_1, injectable_1.Scope.SINGLETON, injectable_1.Side.SERVER),
        tslib_1.__param(0, inject_1.inject("databaseConfigName")),
        tslib_1.__metadata("design:paramtypes", [String])
    ], ModelDAO);
    return ModelDAO;
}(hornet_sequelize_model_1.HornetSequelizeModel));
exports.ModelDAO = ModelDAO;

//# sourceMappingURL=model-dao.js.map
