"use strict";
/**
 * Copyright ou © ou Copr. Ministère de l'Europe et des Affaires étrangères (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * Ce logiciel est un programme informatique servant à faciliter la création
 * d'applications Web conformément aux référentiels généraux français : RGI, RGS et RGAA
 * <p/>
 * Ce logiciel est régi par la licence CeCILL soumise au droit français et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA
 * sur le site "http://www.cecill.info".
 * <p/>
 * En contrepartie de l'accessibilité au code source et des droits de copie,
 * de modification et de redistribution accordés par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
 * seule une responsabilité restreinte pèse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concédants successifs.
 * <p/>
 * A cet égard  l'attention de l'utilisateur est attirée sur les risques
 * associés au chargement,  à l'utilisation,  à la modification et/ou au
 * développement et à la reproduction du logiciel par l'utilisateur étant
 * donné sa spécificité de logiciel libre, qui peut le rendre complexe à
 * manipuler et qui le réserve donc à des développeurs et des professionnels
 * avertis possédant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
 * logiciel à leurs besoins dans des conditions permettant d'assurer la
 * sécurité de leurs systèmes et ou de leurs données et, plus généralement,
 * à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.
 * <p/>
 * Le fait que vous puissiez accéder à cet en-tête signifie que vous avez
 * pris connaissance de la licence CeCILL, et que vous en avez accepté les
 * termes.
 * <p/>
 * <p/>
 * Copyright or © or Copr. Ministry for Europe and Foreign Affairs (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * This software is a computer program whose purpose is to facilitate creation of
 * web application in accordance with french general repositories : RGI, RGS and RGAA.
 * <p/>
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 * <p/>
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 * <p/>
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 * <p/>
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 *
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/**
 * applitutoriel-js-lite - Application tutoriel utilisant le Framework hornet
 *
 * @author MEAE - Ministère de l'Europe et des Affaires étrangères
 * @version v5.4.1
 * @link git+https://github.com/diplomatiegouvfr/applitutoriel-modules.git
 * @license CECILL-2.1
 */
var logger_1 = require("hornet-js-logger/src/logger");
var par_mod_1 = require("applitutoriel-js-common/src/models/par/par-mod");
var Map_1 = require("hornet-js-bean/src/decorators/Map");
var seq_par_mod_1 = require("applitutoriel-js-lite/src/models/par/seq-par-mod");
var hornet_generic_dao_1 = require("hornet-js-database/src/sequelize/hornet-generic-dao");
var inject_1 = require("hornet-js-core/src/inject/inject");
var model_dao_1 = require("applitutoriel-js-lite/src/dao/model-dao");
var injectable_1 = require("hornet-js-core/src/inject/injectable");
var sequelize_utils_1 = require("hornet-js-database/src/sequelize/sequelize-utils");
var promise_api_1 = require("hornet-js-utils/src/promise-api");
var sequelize_1 = require("sequelize");
var Op = require("sequelize/lib/operators");
var logger = logger_1.Logger.getLogger("applitutoriel.src.dao.partenaire-dao");
var PartenaireDAO = /** @class */ (function (_super) {
    tslib_1.__extends(PartenaireDAO, _super);
    function PartenaireDAO(entity, modelDAO) {
        if (entity === void 0) { entity = "partenaireEntity"; }
        return _super.call(this, modelDAO[entity], modelDAO) || this;
    }
    PartenaireDAO.prototype.selectByCriteres = function (client, vip, startDate, sort) {
        var _a;
        if (!sort) {
            sort = [{
                    key: "id_partenaire",
                    dir: 0,
                }];
        }
        var tri = sort[0];
        var seqTri = [tri["key"], (!tri["dir"] || tri["dir"] == 0) ? "ASC" : "DESC"];
        var criteria = {
            where: {
                client: client,
                dateModif: (_a = {},
                    _a[Op.gte] = startDate,
                    _a),
            },
            include: [{
                    model: this.modelDAO.villeEntity,
                    as: "laVille",
                }],
            order: [seqTri],
        };
        if (vip !== undefined) {
            criteria.where["vip"] = vip;
        }
        return this.entity.findAll(criteria);
    };
    PartenaireDAO.prototype.selectFromId = function (id) {
        return this.entity.findOne({
            where: {
                id: id
            },
            include: [{
                    model: this.modelDAO.villeEntity,
                    as: "laVille",
                    include: [{
                            model: this.modelDAO.paysEntity,
                            as: "lePays"
                        }]
                },
                {
                    model: this.modelDAO.paysEntity,
                    as: "laNationalite"
                },
                {
                    model: this.modelDAO.civiliteEntity,
                    as: "laCivilite"
                },
                {
                    model: this.modelDAO.photoEntity,
                    as: "laPhoto"
                },
                {
                    model: this.modelDAO.produitEntity,
                    as: "listeProduit"
                }]
        }).then(function (res) {
            return res;
        });
    };
    PartenaireDAO.prototype.selectAll = function (id) {
        return this.entity.findAll({
            where: {
                id: id
            },
            include: [{
                    model: this.modelDAO.villeEntity,
                    as: "laVille",
                    include: [{
                            model: this.modelDAO.paysEntity,
                            as: "lePays"
                        }]
                },
                {
                    model: this.modelDAO.paysEntity,
                    as: "laNationalite"
                },
                {
                    model: this.modelDAO.civiliteEntity,
                    as: "laCivilite"
                },
                {
                    model: this.modelDAO.photoEntity,
                    as: "laPhoto"
                }]
        });
    };
    PartenaireDAO.prototype.selectByIdSQL = function (id) {
        var query = "SELECT * FROM partenaire " +
            "INNER JOIN ville on partenaire.id_ville = ville.id_ville " +
            "INNER JOIN pays as ville_pays on ville.id_pays = ville_pays.id_pays " +
            "INNER JOIN pays on partenaire.id_pays = pays.id_pays " +
            "INNER JOIN civilite on partenaire.id_civilite = civilite.id_civilite " +
            "LEFT OUTER JOIN photo on partenaire.id_photo = photo.id_photo " +
            "WHERE partenaire.id_partenaire = :identifiant";
        return sequelize_utils_1.SequelizeUtils.getQuery().query(query, {
            replacements: {
                identifiant: id
            },
            model: this.entity,
            type: sequelize_1.QueryTypes.SELECT,
        });
    };
    PartenaireDAO.prototype.deleteByIdIfNotVIP = function (id) {
        return this.entity.destroy({
            where: {
                id: id,
                vip: false,
            },
        });
    };
    PartenaireDAO.prototype.updateById = function (id, partenaire) {
        partenaire.dateModif = new Date();
        this.verificationFormatDonneesPartenaire(partenaire);
        return this.entity.update(partenaire, { where: { id: id } });
    };
    PartenaireDAO.prototype.insert = function (partenaire) {
        partenaire.dateCreat = new Date();
        partenaire.dateModif = new Date();
        this.verificationFormatDonneesPartenaire(partenaire);
        return this.entity.create(partenaire);
    };
    PartenaireDAO.prototype.verificationFormatDonneesPartenaire = function (partenaire) {
        if ((partenaire.dateNaissance) && !(partenaire.dateNaissance instanceof Date)) {
            partenaire.dateNaissance = new Date(partenaire.dateNaissance);
        }
    };
    var _a, _b, _c, _d, _e;
    tslib_1.__decorate([
        Map_1.default(par_mod_1.PartenaireMetier),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", [Boolean, Boolean, Object, Object]),
        tslib_1.__metadata("design:returntype", typeof (_a = typeof promise_api_1.Promise !== "undefined" && promise_api_1.Promise) === "function" ? _a : Object)
    ], PartenaireDAO.prototype, "selectByCriteres", null);
    tslib_1.__decorate([
        Map_1.default(par_mod_1.PartenaireMetier),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", [Number]),
        tslib_1.__metadata("design:returntype", typeof (_b = typeof promise_api_1.Promise !== "undefined" && promise_api_1.Promise) === "function" ? _b : Object)
    ], PartenaireDAO.prototype, "selectFromId", null);
    tslib_1.__decorate([
        Map_1.default(par_mod_1.PartenaireMetier),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", [Object]),
        tslib_1.__metadata("design:returntype", typeof (_c = typeof promise_api_1.Promise !== "undefined" && promise_api_1.Promise) === "function" ? _c : Object)
    ], PartenaireDAO.prototype, "selectAll", null);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__param(1, Map_1.default(seq_par_mod_1.PartenaireDTO)),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", [Number, Object]),
        tslib_1.__metadata("design:returntype", typeof (_d = typeof promise_api_1.Promise !== "undefined" && promise_api_1.Promise) === "function" ? _d : Object)
    ], PartenaireDAO.prototype, "updateById", null);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__param(0, Map_1.default(seq_par_mod_1.PartenaireDTO)),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", [Object]),
        tslib_1.__metadata("design:returntype", typeof (_e = typeof promise_api_1.Promise !== "undefined" && promise_api_1.Promise) === "function" ? _e : Object)
    ], PartenaireDAO.prototype, "insert", null);
    PartenaireDAO = tslib_1.__decorate([
        injectable_1.injectable(),
        tslib_1.__param(1, inject_1.inject(model_dao_1.ModelDAO)),
        tslib_1.__metadata("design:paramtypes", [String, model_dao_1.ModelDAO])
    ], PartenaireDAO);
    return PartenaireDAO;
}(hornet_generic_dao_1.HornetGenericDAO));
exports.PartenaireDAO = PartenaireDAO;

//# sourceMappingURL=partenaire-dao.js.map
