"use strict";
/**
 * Copyright ou © ou Copr. Ministère de l'Europe et des Affaires étrangères (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * Ce logiciel est un programme informatique servant à faciliter la création
 * d'applications Web conformément aux référentiels généraux français : RGI, RGS et RGAA
 * <p/>
 * Ce logiciel est régi par la licence CeCILL soumise au droit français et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA
 * sur le site "http://www.cecill.info".
 * <p/>
 * En contrepartie de l'accessibilité au code source et des droits de copie,
 * de modification et de redistribution accordés par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
 * seule une responsabilité restreinte pèse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concédants successifs.
 * <p/>
 * A cet égard  l'attention de l'utilisateur est attirée sur les risques
 * associés au chargement,  à l'utilisation,  à la modification et/ou au
 * développement et à la reproduction du logiciel par l'utilisateur étant
 * donné sa spécificité de logiciel libre, qui peut le rendre complexe à
 * manipuler et qui le réserve donc à des développeurs et des professionnels
 * avertis possédant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
 * logiciel à leurs besoins dans des conditions permettant d'assurer la
 * sécurité de leurs systèmes et ou de leurs données et, plus généralement,
 * à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.
 * <p/>
 * Le fait que vous puissiez accéder à cet en-tête signifie que vous avez
 * pris connaissance de la licence CeCILL, et que vous en avez accepté les
 * termes.
 * <p/>
 * <p/>
 * Copyright or © or Copr. Ministry for Europe and Foreign Affairs (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * This software is a computer program whose purpose is to facilitate creation of
 * web application in accordance with french general repositories : RGI, RGS and RGAA.
 * <p/>
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 * <p/>
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 * <p/>
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 * <p/>
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 *
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/**
 * applitutoriel-js-lite - Application tutoriel utilisant le Framework hornet
 *
 * @author MEAE - Ministère de l'Europe et des Affaires étrangères
 * @version v5.4.1
 * @link git+https://github.com/diplomatiegouvfr/applitutoriel-modules.git
 * @license CECILL-2.1
 */
var Sequelize = require("sequelize");
var Bean_1 = require("hornet-js-bean/src/decorators/Bean");
var Map_1 = require("hornet-js-bean/src/decorators/Map");
var Alias_1 = require("hornet-js-bean/src/decorators/Alias");
var PartenaireDTO = /** @class */ (function () {
    function PartenaireDTO() {
    }
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", Number)
    ], PartenaireDTO.prototype, "id", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        Alias_1.default("ville.id"),
        tslib_1.__metadata("design:type", Number)
    ], PartenaireDTO.prototype, "ville", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        Alias_1.default("civilite.id"),
        tslib_1.__metadata("design:type", Number)
    ], PartenaireDTO.prototype, "civilite", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        Alias_1.default("nationalite.id"),
        tslib_1.__metadata("design:type", Number)
    ], PartenaireDTO.prototype, "nationalite", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        Alias_1.default("photo.id"),
        tslib_1.__metadata("design:type", Number)
    ], PartenaireDTO.prototype, "photo", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", Boolean)
    ], PartenaireDTO.prototype, "client", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", Boolean)
    ], PartenaireDTO.prototype, "vip", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", String)
    ], PartenaireDTO.prototype, "nom", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", String)
    ], PartenaireDTO.prototype, "prenom", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", String)
    ], PartenaireDTO.prototype, "nomLocal", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", String)
    ], PartenaireDTO.prototype, "prenomLocal", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", Date)
    ], PartenaireDTO.prototype, "dateNaissance", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", String)
    ], PartenaireDTO.prototype, "organisme", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", String)
    ], PartenaireDTO.prototype, "fonction", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", String)
    ], PartenaireDTO.prototype, "proTelFixe", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", String)
    ], PartenaireDTO.prototype, "proTelPort", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", String)
    ], PartenaireDTO.prototype, "proCourriel", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", String)
    ], PartenaireDTO.prototype, "proFax", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", String)
    ], PartenaireDTO.prototype, "proAdrRue", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", String)
    ], PartenaireDTO.prototype, "proAdrCP", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", String)
    ], PartenaireDTO.prototype, "assistNom", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", String)
    ], PartenaireDTO.prototype, "assistPrenom", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", String)
    ], PartenaireDTO.prototype, "assistTel", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", String)
    ], PartenaireDTO.prototype, "assistCourriel", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", String)
    ], PartenaireDTO.prototype, "commentaire", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", Object)
    ], PartenaireDTO.prototype, "satisfaction", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", String)
    ], PartenaireDTO.prototype, "dateCreat", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", String)
    ], PartenaireDTO.prototype, "dateModif", void 0);
    tslib_1.__decorate([
        Map_1.default(),
        tslib_1.__metadata("design:type", Array)
    ], PartenaireDTO.prototype, "listeProduit", void 0);
    PartenaireDTO = tslib_1.__decorate([
        Bean_1.default
    ], PartenaireDTO);
    return PartenaireDTO;
}());
exports.PartenaireDTO = PartenaireDTO;
exports.PartenaireModel = {
    id: {
        type: Sequelize.INTEGER,
        field: "id_partenaire",
        autoIncrement: true,
        primaryKey: true
    },
    ville: {
        type: Sequelize.INTEGER,
        field: "id_ville",
        allowNull: false,
        references: {
            model: "VilleModel",
            key: "id"
        }
    },
    civilite: {
        type: Sequelize.INTEGER,
        field: "id_civilite",
        allowNull: false,
        references: {
            model: "CiviliteModel",
            key: "id"
        }
    },
    nationalite: {
        type: Sequelize.INTEGER,
        field: "id_pays",
        allowNull: false,
        references: {
            model: "PaysModel",
            key: "id"
        }
    },
    photo: {
        type: Sequelize.INTEGER,
        field: "id_photo",
        references: {
            model: "PhotoModel",
            key: "id"
        }
    },
    client: {
        type: Sequelize.BOOLEAN,
        field: "par_is_client"
    },
    vip: {
        type: Sequelize.BOOLEAN,
        field: "par_is_vip"
    },
    nom: {
        type: Sequelize.STRING(50),
        field: "par_nom"
    },
    prenom: {
        type: Sequelize.STRING(50),
        field: "par_prenom"
    },
    nomLocal: {
        type: Sequelize.STRING(50),
        field: "par_nom_local"
    },
    prenomLocal: {
        type: Sequelize.STRING(50),
        field: "par_prenom_local"
    },
    dateNaissance: {
        type: Sequelize.DATE,
        field: "par_date_naissance",
    },
    organisme: {
        type: Sequelize.STRING(50),
        field: "par_organisme",
    },
    fonction: {
        type: Sequelize.STRING(50),
        field: "par_fonction",
    },
    proTelFixe: {
        type: Sequelize.STRING(16),
        field: "par_pro_tel_fixe",
    },
    proTelPort: {
        type: Sequelize.STRING(16),
        field: "par_pro_tel_port",
    },
    proCourriel: {
        type: Sequelize.STRING(80),
        field: "par_pro_courriel",
    },
    proFax: {
        type: Sequelize.STRING(16),
        field: "par_pro_fax",
    },
    proAdrRue: {
        type: Sequelize.STRING(250),
        field: "par_pro_adr_rue",
    },
    proAdrCP: {
        type: Sequelize.STRING(9),
        field: "par_pro_adr_cp",
    },
    assistNom: {
        type: Sequelize.STRING(50),
        field: "par_assist_nom",
    },
    assistPrenom: {
        type: Sequelize.STRING(50),
        field: "par_assist_prenom",
    },
    assistTel: {
        type: Sequelize.STRING(16),
        field: "par_assist_tel",
    },
    assistCourriel: {
        type: Sequelize.STRING(80),
        field: "par_assist_courriel",
    },
    commentaire: {
        type: Sequelize.STRING(500),
        field: "par_commentaire",
    },
    satisfaction: {
        type: Sequelize.STRING(500),
        field: "par_satisfaction",
    },
    dateCreat: {
        type: Sequelize.DATE,
        field: "par_date_creation",
    },
    dateModif: {
        type: Sequelize.DATEONLY,
        field: "par_date_modification",
    },
};

//# sourceMappingURL=seq-par-mod.js.map
