"use strict";
/**
 * Copyright ou © ou Copr. Ministère de l'Europe et des Affaires étrangères (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * Ce logiciel est un programme informatique servant à faciliter la création
 * d'applications Web conformément aux référentiels généraux français : RGI, RGS et RGAA
 * <p/>
 * Ce logiciel est régi par la licence CeCILL soumise au droit français et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA
 * sur le site "http://www.cecill.info".
 * <p/>
 * En contrepartie de l'accessibilité au code source et des droits de copie,
 * de modification et de redistribution accordés par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
 * seule une responsabilité restreinte pèse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concédants successifs.
 * <p/>
 * A cet égard  l'attention de l'utilisateur est attirée sur les risques
 * associés au chargement,  à l'utilisation,  à la modification et/ou au
 * développement et à la reproduction du logiciel par l'utilisateur étant
 * donné sa spécificité de logiciel libre, qui peut le rendre complexe à
 * manipuler et qui le réserve donc à des développeurs et des professionnels
 * avertis possédant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
 * logiciel à leurs besoins dans des conditions permettant d'assurer la
 * sécurité de leurs systèmes et ou de leurs données et, plus généralement,
 * à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.
 * <p/>
 * Le fait que vous puissiez accéder à cet en-tête signifie que vous avez
 * pris connaissance de la licence CeCILL, et que vous en avez accepté les
 * termes.
 * <p/>
 * <p/>
 * Copyright or © or Copr. Ministry for Europe and Foreign Affairs (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * This software is a computer program whose purpose is to facilitate creation of
 * web application in accordance with french general repositories : RGI, RGS and RGAA.
 * <p/>
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 * <p/>
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 * <p/>
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 * <p/>
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 *
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/**
 * applitutoriel-js-lite - Application tutoriel utilisant le Framework hornet
 *
 * @author MEAE - Ministère de l'Europe et des Affaires étrangères
 * @version v5.4.1
 * @link git+https://github.com/diplomatiegouvfr/applitutoriel-modules.git
 * @license CECILL-2.1
 */
// L'import de hornet-js-utils doit être fait le plus tôt possible
var hornet_js_utils_1 = require("hornet-js-utils");
var logger_1 = require("hornet-js-logger/src/logger");
var fs = require("fs");
var app_i18n_loader_1 = require("applitutoriel-js-common/src/i18n/app-i18n-loader");
var HornetServer = require("hornet-js-core/src/server");
var hornet_app_1 = require("applitutoriel-js-common/src/views/layouts/hornet-app");
var hornet_layout_1 = require("applitutoriel-js-common/src/views/layouts/hornet-layout");
var error_page_1 = require("hornet-js-react-components/src/widget/component/error-page");
// import { AuthenticationAPIMiddleware } from "src/middleware/authentication-api";
var routes_1 = require("applitutoriel-js-lite/src/routes/routes");
var component_middleware_1 = require("hornet-js-react-components/src/middleware/component-middleware");
var HornetMiddlewares = require("hornet-js-core/src/middleware/middlewares");
var DataBaseMiddlewares = require("hornet-js-database/src/middleware/middleware");
// Authent passport
var passport_authentication_1 = require("hornet-js-passport/src/passport-authentication");
var authentication_configuration_1 = require("hornet-js-passport/src/authentication-configuration");
// Saml
var saml_configuration_1 = require("hornet-js-passport/src/strategy/saml/saml-configuration");
var saml_strategy_1 = require("hornet-js-passport/src/strategy/saml/saml-strategy");
var database_1 = require("hornet-js-database/src/sequelize/database");
var injector_1 = require("hornet-js-core/src/inject/injector");
var Menu = require("applitutoriel-js-common/src/resources/navigation.json");
// Mise en place des injections de service
var logger = logger_1.Logger.getLogger("applitutoriel.server");
function initContext() {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, Promise.resolve().then(function () { return require("applitutoriel-js-lite/src/injector-context-services-data"); })];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, Promise.resolve().then(function () { return require("applitutoriel-js-lite/src/injector-context-services-page"); })];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, Promise.resolve().then(function () { return require("applitutoriel-js-common/src/middleware/authentication-api"); })];
                case 3: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
var AuthenticationAPIMiddleware;
/*
let AuthenticationAPIMiddleware;
initContext().then(
    (AuthenticationAPI)=> {
        AuthenticationAPIMiddleware = AuthenticationAPI
    });
*/
var Server = /** @class */ (function () {
    function Server() {
    }
    Server.configure = function () {
        var configServer = {
            serverDir: __dirname,
            staticPath: "../static",
            appComponent: hornet_app_1.HornetApp,
            layoutComponent: hornet_layout_1.HornetLayout,
            errorComponent: error_page_1.ErrorPage,
            defaultRoutesClass: new routes_1.Routes(),
            sessionStore: null,
            routesLoaderPaths: ["src/routes/"],
            /*Directement un flux JSON >>internationalization:require("./i18n/messages-fr-FR.json"),*/
            /*Sans utiliser le système clé/valeur>> internationalization:null,*/
            internationalization: new app_i18n_loader_1.AppliI18nLoader(),
            menuConfig: Menu.menu,
            loginUrl: hornet_js_utils_1.Utils.config.get("authentication.loginUrl"),
            logoutUrl: hornet_js_utils_1.Utils.config.get("authentication.logoutUrl"),
            welcomePageUrl: hornet_js_utils_1.Utils.config.get("welcomePage"),
            publicZones: [
                hornet_js_utils_1.Utils.config.get("welcomePage")
            ]
        };
        var key = hornet_js_utils_1.Utils.config.getOrDefault("server.https.key", false);
        var cert = hornet_js_utils_1.Utils.config.getOrDefault("server.https.cert", false);
        if (key && cert) {
            configServer.httpsOptions = {
                key: fs.readFileSync(key, "utf8"),
                cert: fs.readFileSync(cert, "utf8"),
                passphrase: hornet_js_utils_1.Utils.config.get("server.https.passphrase")
            };
        }
        return configServer;
    };
    Server.middleware = function () {
        var hornetMiddlewareList = new HornetMiddlewares.HornetMiddlewareList()
            .addAfter(component_middleware_1.PageRenderingMiddleware, HornetMiddlewares.UserAccessSecurityMiddleware)
            .addAfter(component_middleware_1.UnmanagedViewErrorMiddleware, HornetMiddlewares.DataRenderingMiddleware)
            .addBefore(DataBaseMiddlewares.DataBaseErrorMiddleware, HornetMiddlewares.UnmanagedDataErrorMiddleware);
        if (hornet_js_utils_1.Utils.config.getOrDefault("authentication.saml.enabled", false)) {
            var configAuth = new authentication_configuration_1.AuthenticationtConfiguration(hornet_js_utils_1.Utils.config.get("authentication.loginUrl"), hornet_js_utils_1.Utils.config.get("authentication.logoutUrl"));
            var authent = new passport_authentication_1.PassportAuthentication(configAuth);
            var configuration = new saml_configuration_1.SamlConfiguration(hornet_js_utils_1.Utils.config.get("authentication.saml.configuration.callbackUrl"), hornet_js_utils_1.Utils.config.get("authentication.saml.configuration.logoutCallbackUrl"), 
            // Page de retour par défaut
            hornet_js_utils_1.Utils.config.get("authentication.saml.configuration.hostUrlReturnTo"), 
            // Usually specified as `/shibboleth` from site root
            hornet_js_utils_1.Utils.config.get("authentication.saml.configuration.issuer"), fs.readFileSync(hornet_js_utils_1.Utils.config.get("authentication.saml.configuration.cert"), "utf8"), 
            // Clé privée de décryptage
            fs.readFileSync(hornet_js_utils_1.Utils.config.get("authentication.saml.configuration.key"), "utf8"), hornet_js_utils_1.Utils.config.get("authentication.saml.configuration.idp"));
            authent.initStrategy(new saml_strategy_1.SamlStrategy(configuration));
            hornetMiddlewareList.addAfter(authent.getMiddleware(), HornetMiddlewares.ChangeI18nLocaleMiddleware);
        }
        else {
            hornetMiddlewareList.addAfter(AuthenticationAPIMiddleware, HornetMiddlewares.ChangeI18nLocaleMiddleware);
        }
        return hornetMiddlewareList;
    };
    Server.startApplication = function () {
        initContext().then(function (AuthenticationAPI) {
            if (process.env.NODE_ENV !== "production" &&
                !hornet_js_utils_1.Utils.config.getOrDefault("mock.enabled", false) &&
                !hornet_js_utils_1.Utils.config.getOrDefault("mock.serviceData.enabled", false)) {
                var files = void 0;
                var databaseConfName = injector_1.Injector.getRegistered("databaseConfigName");
                if (databaseConfName === "config") {
                    files = ["database/01_createTablesSqlite.sql", "database/02_initDataSqlite.sql"];
                }
                else if (databaseConfName === "configPostgres") {
                    files = ["database/01_createTablesPostgres.sql", "database/02_initDataPostgres.sql"];
                }
                database_1.Database.runScripts([{
                        configName: databaseConfName,
                        files: files
                    }]).then(function () {
                    Server.start(AuthenticationAPI);
                });
            }
            else {
                Server.start(AuthenticationAPI);
            }
        });
    };
    Server.start = function (AuthenticationAPI) {
        AuthenticationAPIMiddleware = AuthenticationAPI.AuthenticationAPIMiddleware;
        var server = new HornetServer.Server(Server.configure(), Server.middleware());
        server.start();
    };
    return Server;
}());
exports.Server = Server;

//# sourceMappingURL=server.js.map
