"use strict";
/**
 * Copyright ou © ou Copr. Ministère de l'Europe et des Affaires étrangères (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * Ce logiciel est un programme informatique servant à faciliter la création
 * d'applications Web conformément aux référentiels généraux français : RGI, RGS et RGAA
 * <p/>
 * Ce logiciel est régi par la licence CeCILL soumise au droit français et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA
 * sur le site "http://www.cecill.info".
 * <p/>
 * En contrepartie de l'accessibilité au code source et des droits de copie,
 * de modification et de redistribution accordés par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
 * seule une responsabilité restreinte pèse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concédants successifs.
 * <p/>
 * A cet égard  l'attention de l'utilisateur est attirée sur les risques
 * associés au chargement,  à l'utilisation,  à la modification et/ou au
 * développement et à la reproduction du logiciel par l'utilisateur étant
 * donné sa spécificité de logiciel libre, qui peut le rendre complexe à
 * manipuler et qui le réserve donc à des développeurs et des professionnels
 * avertis possédant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
 * logiciel à leurs besoins dans des conditions permettant d'assurer la
 * sécurité de leurs systèmes et ou de leurs données et, plus généralement,
 * à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.
 * <p/>
 * Le fait que vous puissiez accéder à cet en-tête signifie que vous avez
 * pris connaissance de la licence CeCILL, et que vous en avez accepté les
 * termes.
 * <p/>
 * <p/>
 * Copyright or © or Copr. Ministry for Europe and Foreign Affairs (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * This software is a computer program whose purpose is to facilitate creation of
 * web application in accordance with french general repositories : RGI, RGS and RGAA.
 * <p/>
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 * <p/>
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 * <p/>
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 * <p/>
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 *
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/**
 * applitutoriel-js-lite - Application tutoriel utilisant le Framework hornet
 *
 * @author MEAE - Ministère de l'Europe et des Affaires étrangères
 * @version v5.4.1
 * @link git+https://github.com/diplomatiegouvfr/applitutoriel-modules.git
 * @license CECILL-2.1
 */
var logger_1 = require("hornet-js-logger/src/logger");
var business_error_1 = require("hornet-js-utils/src/exception/business-error");
var partenaire_service_1 = require("applitutoriel-js-common/src/services/data/par/partenaire-service");
var partenaire_dao_1 = require("applitutoriel-js-lite/src/dao/partenaire-dao");
var ville_dao_1 = require("applitutoriel-js-lite/src/dao/ville-dao");
var pays_dao_1 = require("applitutoriel-js-lite/src/dao/pays-dao");
var produit_partenaire_dao_1 = require("applitutoriel-js-lite/src/dao/produit-partenaire-dao");
var photo_dao_1 = require("applitutoriel-js-lite/src/dao/photo-dao");
var dec_transactional_1 = require("hornet-js-database/src/decorators/dec-transactional");
var secteur_service_impl_1 = require("applitutoriel-js-lite/src/services/data/sec/secteur-service-impl");
var injector_1 = require("hornet-js-core/src/inject/injector");
var promise_api_1 = require("hornet-js-utils/src/promise-api");
var ref_pay_mod_1 = require("applitutoriel-js-common/src/models/ref/ref-pay-mod");
var logger = logger_1.Logger.getLogger("applitutoriel.src.services.data.par.partenaire-service-impl");
var TablePartenaireImpl = /** @class */ (function () {
    function TablePartenaireImpl() {
    }
    return TablePartenaireImpl;
}());
var PartenaireResultImpl = /** @class */ (function () {
    function PartenaireResultImpl() {
    }
    return PartenaireResultImpl;
}());
/**
 * Implementation des services de recherche pour les partenaires
 * @class
 * @implements {PartenaireService, IService}
 */
var PartenaireServiceImpl = /** @class */ (function (_super) {
    tslib_1.__extends(PartenaireServiceImpl, _super);
    function PartenaireServiceImpl() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.partenaireDAO = new partenaire_dao_1.PartenaireDAO();
        _this.produitPartenaireDAO = new produit_partenaire_dao_1.ProduitPartenaireDAO();
        // DAO des villes
        _this.villeDAO = new ville_dao_1.VilleDAO();
        // DAO des pays
        _this.paysDAO = new pays_dao_1.PaysDAO();
        //  DAO des photos
        _this.photoDAO = new photo_dao_1.PhotoDAO();
        //  service de gestion des partenaires
        _this.secteurApi = new secteur_service_impl_1.SecteurServiceImpl();
        return _this;
    }
    PartenaireServiceImpl.prototype.rechercher = function (data, reqMimeType) {
        var _this = this;
        logger.trace("SERVICES - rechercher : ", data, reqMimeType);
        function nullToBoolean(nullData) {
            if (nullData == null) {
                nullData = false;
            }
            return nullData;
        }
        var isClient = nullToBoolean(data.criteres.partenaire.client);
        var keysort = (data.sort ? data.sort[0].key : "id_partenaire");
        var p = this.partenaireDAO.selectByCriteres(isClient, data.criteres.partenaire.vip, data.criteres.startDate, data.sort);
        return p.then(function (listPartenaire) {
            var tablePartenaire = new TablePartenaireImpl();
            tablePartenaire.nbTotal = listPartenaire.length;
            tablePartenaire.pagination = _this.paginationServer(data.pagination, listPartenaire);
            tablePartenaire.listeCriteres = data.criteres;
            tablePartenaire.liste = new Array();
            var filteredListPartenaire = _this.selectionListePartenaire(tablePartenaire.pagination, listPartenaire);
            filteredListPartenaire.forEach(function (partenaire) {
                var partenaireResult = new PartenaireResultImpl();
                partenaireResult.id = partenaire.id;
                partenaireResult.nom = partenaire.nom;
                partenaireResult.prenom = partenaire.prenom;
                partenaireResult.proCourriel = partenaire.proCourriel;
                partenaireResult.organisme = partenaire.organisme;
                partenaireResult.vip = partenaire.vip;
                partenaireResult.dateModif = partenaire.dateModif;
                tablePartenaire.liste.push(partenaireResult);
            });
            return tablePartenaire;
        });
    };
    PartenaireServiceImpl.prototype.selectionListePartenaire = function (pagination, dataPartenaires) {
        // Pagination serveur
        var minIndex = (pagination.pageIndex - 1) * pagination.itemsPerPage;
        var maxIndex = Math.min(pagination.totalItems, minIndex + pagination.itemsPerPage);
        return dataPartenaires.slice(minIndex, maxIndex);
    };
    PartenaireServiceImpl.prototype.paginationServer = function (pagination, dataPartenaires) {
        var res = pagination || { itemsPerPage: 0 };
        res.totalItems = dataPartenaires.length;
        if (!res.pageIndex || res.pageIndex === 0) {
            res.pageIndex = 1;
        }
        var itemsPerPage = !res.itemsPerPage || res.itemsPerPage === 0 ? 10 : res.itemsPerPage;
        // Recuperation du nombre total de pages
        var nombrePages = Math.max(1, Math.ceil(res.totalItems / itemsPerPage));
        // Recalcul indexPage
        var indexPagePartenaires = Math.min(res.pageIndex, nombrePages);
        res.pageIndex = indexPagePartenaires;
        res.itemsPerPage = itemsPerPage;
        return res;
    };
    /**
     * Suppression d'un partenaire
     */
    PartenaireServiceImpl.prototype.supprimer = function (id) {
        return this.suppressionDunPartenaire(id).then(function (retour) {
            return true;
        }).catch(function (error) {
            return false;
        });
    };
    PartenaireServiceImpl.prototype.supprimerPage = function (id) {
        // Non utilisée
        return promise_api_1.Promise.resolve(false);
    };
    PartenaireServiceImpl.prototype.supprimerEnMasse = function (partenaires) {
        return this.suppressionDesPartenaires(partenaires)
            .catch(function (error) {
            return {};
        }).then(function (identifiants) {
            return identifiants;
        });
    };
    PartenaireServiceImpl.prototype.suppressionDesPartenaires = function (partenaires) {
        var _this = this;
        return new promise_api_1.Promise(function (resolve, reject) {
            var idsConfirmation = new Array();
            var idsError = new Array();
            return promise_api_1.Promise.each(partenaires, function (partenaire) {
                return _this.suppressionDunPartenaire(partenaire.id).then(function (result) {
                    idsConfirmation.push(partenaire.id);
                }).catch(function (error) {
                    idsError.push(partenaire.id);
                });
            }).catch(function (error) {
                reject(error);
            }).then(function (result) {
                resolve(idsConfirmation);
            });
        });
    };
    PartenaireServiceImpl.prototype.suppressionDunPartenaire = function (id) {
        var _this = this;
        return this.produitPartenaireDAO.deleteByIdGeneric(id).then(function () {
            return _this.partenaireDAO.deleteByIdIfNotVIP(id);
        });
    };
    PartenaireServiceImpl.prototype.editer = function (id, data) {
        return this.partenaireDAO.updateById(id, data).catch(function (err) {
            throw new business_error_1.BusinessError(err);
        });
    };
    PartenaireServiceImpl.prototype.creer = function (data, cb) {
        this.partenaireDAO.insert(data).catch(function (err) {
            throw new business_error_1.BusinessError(err);
        }).then(cb);
    };
    /**
     * Cherche le partenaire et ses informations pour un id
     */
    PartenaireServiceImpl.prototype.chercherPartenaireById = function (id) {
        return this.partenaireDAO.selectFromId(id)
            .catch(function (err) {
            throw new business_error_1.BusinessError(err);
        });
    };
    PartenaireServiceImpl.prototype.chercherPartenairesByIds = function (ids) {
        return this.partenaireDAO.selectAll(ids)
            .catch(function (err) {
            throw new business_error_1.BusinessError(err);
        });
    };
    PartenaireServiceImpl.prototype.exporter = function (reqMimeType) {
        logger.trace("SERVICES - exporter : ", reqMimeType);
        return promise_api_1.Promise.resolve(true);
    };
    PartenaireServiceImpl.prototype.exporterODF = function (reqMimeType) {
        logger.trace("SERVICES - exporterODF : ", reqMimeType);
        return promise_api_1.Promise.resolve(true);
    };
    PartenaireServiceImpl.prototype.listerSecteurs = function () {
        return this.secteurApi.lister().then(function (results) {
            logger.log("results", results);
        });
    };
    /**
     * Récupère les données liés au partenaires
     * @param id du partenaire
     * @return Promise<object>
     */
    PartenaireServiceImpl.prototype.fichePartenaire = function (id) {
        logger.trace("fichePartenaire id :", id);
        return this.partenaireDAO.selectFromId(id).then(function (result) {
            var res = result;
            if (res && res.satisfaction) {
                res.satisfaction = { ids: res.satisfaction.split(",") };
            }
            return res;
        });
    };
    /**
     * Récupère les données nécessaires pour l'affichage du partenaire
     * @return Promise<object>
     */
    PartenaireServiceImpl.prototype.getFormData = function () {
        return promise_api_1.Promise.all([this.villeDAO.listerVilles(), this.paysDAO.findAllGeneric(null, ref_pay_mod_1.PaysMetier)])
            .then(function (results) {
            return ({
                villes: results[0],
                pays: results[1]
            });
        });
    };
    /**
     * Modifie ou crée un partenaire en base
     * @return Promise<object>
     */
    PartenaireServiceImpl.prototype.modifier = function (id, partenaire) {
        var _this = this;
        logger.trace("modifier id :", id);
        if (partenaire.satisfaction.ids) {
            partenaire.satisfaction = partenaire.satisfaction.ids.join(",");
        }
        else {
            partenaire.satisfaction = "";
        }
        partenaire.vip = this.isPartenaireVip(partenaire.vip);
        return this.insertPhoto(partenaire).then(function (retourPartenaire) {
            if (id != null) {
                retourPartenaire.id = id;
                return _this.partenaireDAO.updateById(id, retourPartenaire).then(function (retourApi) {
                    logger.trace("Retour d\"enregistrement OK", retourApi);
                    return retourApi;
                });
            }
            else {
                return _this.partenaireDAO.insert(retourPartenaire).then(function (retourApi) {
                    logger.trace("Retour d\"enregistrement OK", retourApi);
                    return retourApi;
                });
            }
        });
    };
    PartenaireServiceImpl.prototype.isPartenaireVip = function (vip) {
        var res = vip;
        if (vip === "undefined" || vip == null) {
            res = false;
        }
        return res;
    };
    /**
     * Insère la photo du partenaire s'il celle-ci existe.
     * @return Promise<object>
     */
    PartenaireServiceImpl.prototype.insertPhoto = function (partenaire) {
        if (partenaire.photo != null) {
            return this.photoDAO.insert(partenaire.photo).then(function (retourApi) {
                logger.trace("Retour d\"enregistrement OK", retourApi);
                partenaire.photo.id = retourApi.id;
                return partenaire;
            });
        }
        else {
            return promise_api_1.Promise.resolve(partenaire);
        }
    };
    /**
     * Récupère la photo du partenaire
     * @return Promise<object>
     */
    PartenaireServiceImpl.prototype.lirePhoto = function (idPartenaire) {
        logger.trace("lirePhoto du partenaire id :", idPartenaire);
        return this.partenaireDAO.selectFromId(idPartenaire).then(function (partenaire) {
            if (!partenaire.photo)
                throw new business_error_1.BusinessError("ER-PA-FPA-10");
            return partenaire.photo;
        });
    };
    var _a, _b;
    tslib_1.__decorate([
        dec_transactional_1.Transactional({ configDatabase: injector_1.Injector.getRegistered("databaseConfigName") }),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", [Number]),
        tslib_1.__metadata("design:returntype", typeof (_a = typeof promise_api_1.Promise !== "undefined" && promise_api_1.Promise) === "function" ? _a : Object)
    ], PartenaireServiceImpl.prototype, "suppressionDunPartenaire", null);
    tslib_1.__decorate([
        dec_transactional_1.Transactional({ configDatabase: injector_1.Injector.getRegistered("databaseConfigName") }),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", [Object, Object]),
        tslib_1.__metadata("design:returntype", typeof (_b = typeof promise_api_1.Promise !== "undefined" && promise_api_1.Promise) === "function" ? _b : Object)
    ], PartenaireServiceImpl.prototype, "modifier", null);
    return PartenaireServiceImpl;
}(partenaire_service_1.PartenaireService));
exports.PartenaireServiceImpl = PartenaireServiceImpl;

//# sourceMappingURL=partenaire-service-impl.js.map
