"use strict";
/**
 * Copyright ou © ou Copr. Ministère de l'Europe et des Affaires étrangères (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * Ce logiciel est un programme informatique servant à faciliter la création
 * d'applications Web conformément aux référentiels généraux français : RGI, RGS et RGAA
 * <p/>
 * Ce logiciel est régi par la licence CeCILL soumise au droit français et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA
 * sur le site "http://www.cecill.info".
 * <p/>
 * En contrepartie de l'accessibilité au code source et des droits de copie,
 * de modification et de redistribution accordés par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
 * seule une responsabilité restreinte pèse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concédants successifs.
 * <p/>
 * A cet égard  l'attention de l'utilisateur est attirée sur les risques
 * associés au chargement,  à l'utilisation,  à la modification et/ou au
 * développement et à la reproduction du logiciel par l'utilisateur étant
 * donné sa spécificité de logiciel libre, qui peut le rendre complexe à
 * manipuler et qui le réserve donc à des développeurs et des professionnels
 * avertis possédant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
 * logiciel à leurs besoins dans des conditions permettant d'assurer la
 * sécurité de leurs systèmes et ou de leurs données et, plus généralement,
 * à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.
 * <p/>
 * Le fait que vous puissiez accéder à cet en-tête signifie que vous avez
 * pris connaissance de la licence CeCILL, et que vous en avez accepté les
 * termes.
 * <p/>
 * <p/>
 * Copyright or © or Copr. Ministry for Europe and Foreign Affairs (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * This software is a computer program whose purpose is to facilitate creation of
 * web application in accordance with french general repositories : RGI, RGS and RGAA.
 * <p/>
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 * <p/>
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 * <p/>
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 * <p/>
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 *
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/**
 * applitutoriel-js-lite - Application tutoriel utilisant le Framework hornet
 *
 * @author MEAE - Ministère de l'Europe et des Affaires étrangères
 * @version v5.4.1
 * @link git+https://github.com/diplomatiegouvfr/applitutoriel-modules.git
 * @license CECILL-2.1
 */
var hornet_js_utils_1 = require("hornet-js-utils");
var logger_1 = require("hornet-js-logger/src/logger");
var service_page_1 = require("hornet-js-core/src/services/service-page");
var urls_1 = require("applitutoriel-js-common/src/utils/urls");
var ref_pays_service_impl_1 = require("applitutoriel-js-lite/src/services/page/ref/ref-pays-service-impl");
var hornet_superagent_request_1 = require("hornet-js-core/src/services/hornet-superagent-request");
var promise_api_1 = require("hornet-js-utils/src/promise-api");
var logger = logger_1.Logger.getLogger("applitutoriel.services.page.par.par-fpa-service-page-impl");
/**
 * Implementation des services pour les partenaires
 * @class
 * @implements {FichePartenaireService}
 * @extends {ServiceApi}
 */
var FichePartenaireServiceImpl = /** @class */ (function (_super) {
    tslib_1.__extends(FichePartenaireServiceImpl, _super);
    function FichePartenaireServiceImpl() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /** service de gestion des pays */
        _this.paysApi = new ref_pays_service_impl_1.ReferentielPaysServiceImpl();
        return _this;
    }
    /**
     * liste tous les secteurs
     * @return Promise
     */
    FichePartenaireServiceImpl.prototype.listerSecteurs = function () {
        logger.trace("SERVICES - lister");
        return this.fetch({ method: "get", url: this.buildUrl(urls_1.URL_SECTEURS) });
    };
    /**
     * liste les produit
     * @param {number} id identifiant du partenaire à récupérer
     * @return Promise
     */
    FichePartenaireServiceImpl.prototype.fichePartenaire = function (id) {
        var url = urls_1.URL_PARTENAIRES;
        var p;
        if (id) {
            url += "/" + id;
        }
        return this.fetch({ method: "get", url: this.buildUrl(url) });
    };
    /**
     * Récupère les données nécessaires à l'écran de fiche partenaire
     * @return Promise<object>
     */
    FichePartenaireServiceImpl.prototype.getFormData = function () {
        var _this = this;
        return this.paysApi.listerVilles().then(function (villes) {
            return _this.paysApi.listerPays().then(function (pays) {
                return promise_api_1.Promise.resolve({ villes: villes, pays: pays });
            });
        });
    };
    FichePartenaireServiceImpl.prototype.rechercherNationalites = function (nationalite, spinner) {
        if (spinner === void 0) { spinner = hornet_superagent_request_1.SpinnerType.Default; }
        return this.paysApi.rechercherNationalites(nationalite, spinner);
    };
    /**
     * Création / Modifiaction d'un partenaire existant
     * @param {number} id identifiant du partenaire à modifier
     * @param {object} partenaire partenaire à modifier
     * @param {object} process function à appeler pendant la progress de la request
     * @return Promise<object>
     */
    FichePartenaireServiceImpl.prototype.modifier = function (id, partenaire, progress) {
        var request = { method: "put", url: this.buildUrl(urls_1.URL_PARTENAIRES) + "/" + id };
        if (!id) {
            request = { method: "post", url: this.buildUrl(urls_1.URL_PARTENAIRES) };
        }
        if (hornet_js_utils_1.Utils.isServer) {
            // On est sur NodeJS et on envoi vers le backend, on encode donc la photo en JSON et on POST de manière "classique"
            request.data = this.convertToRemotePartenaire(partenaire);
        }
        else {
            // On est sur le browser, on va encoder le POST en multipart et transférer le corps en JSON et l"image dans un "part" séparé
            request.data = partenaire;
            if (partenaire.photo && partenaire.photo instanceof File) {
                // mantis 55104
                // L'objet photo est de type "File" seulement
                // quand un fichier est a été uploadé dans le formulaire et transmis dans la requête
                // Si ce n'est pas un fichier, on peut l'ignorer (cela signifie que la photo n'a pas changé)
                // De plus, si on essaye quand même de l'attacher dans la requête alors que ce n'est pas un fichier,
                // firefox plante (Argument 2 of FormData.append does not implement interface Blob)
                request.attach = [];
                request.attach.push({ field: "photo", file: partenaire.photo, fileName: partenaire.photo.name });
                request.progress = progress;
            }
        }
        return this.fetch(request);
    };
    /**
     * Récupère la photo associée partenaire
     * @param {number} id identifiant du partenaire dont on souhaite la photo
     * @return Promise<object>
     */
    FichePartenaireServiceImpl.prototype.lirePhoto = function (id, res) {
        logger.trace("SERVICES - lirePhoto : ", id);
        if (res) {
            return this.fetchOnStream({
                method: "get",
                url: this.buildUrl(urls_1.URL_PARTENAIRES + "/" + id + urls_1.URL_PAR_PHOTO)
            }, res);
        }
        return this.fetch({ method: "get", url: this.buildUrl(urls_1.URL_PARTENAIRES + "/" + id + urls_1.URL_PAR_PHOTO) });
    };
    /**
     * node >v10 does not parse JSON buffer too a buffer so we must detect and create a buffer
     * @param buff
     * @returns {*}
     */
    FichePartenaireServiceImpl.prototype.convertBufferToArray = function (buff) {
        var buffer = buff;
        if (buff !== undefined && Buffer.isBuffer(buff)) {
            buffer = Buffer.from(buff).toJSON();
        }
        return buffer;
    };
    /**
     * convertion d'un partenaire
     * @param {object} webPartenaire
     * @returns {object}
     */
    FichePartenaireServiceImpl.prototype.convertToRemotePartenaire = function (webPartenaire) {
        var remotePartenaire = tslib_1.__assign({}, webPartenaire);
        remotePartenaire.satisfaction =
            (Array.isArray(webPartenaire.satisfaction)) ? webPartenaire.satisfaction.join(",") : webPartenaire.satisfaction;
        if (remotePartenaire.photo && remotePartenaire.photo.contenu) {
            var photo = remotePartenaire.photo;
            var buffer = this.convertBufferToArray(photo.contenu);
            remotePartenaire.photo = {
                id: null,
                nom: photo.originalname,
                originalname: photo.originalname,
                name: photo.originalname,
                mimeType: photo.mimeType,
                encoding: photo.encoding,
                size: photo.size,
                data: buffer.data
            };
            photo = null;
        }
        return remotePartenaire;
    };
    return FichePartenaireServiceImpl;
}(service_page_1.ServicePage));
exports.FichePartenaireServiceImpl = FichePartenaireServiceImpl;

//# sourceMappingURL=par-fpa-service-page-impl.js.map
